" File wireI.self
 created by Ian Wilkinson on Thu Sep 10 15:38:48 1992

 Copyright (c) Canon Research Centre Europe, 1992.
 All rights reserved."

prototypes system _AddSlotsIfAbsent: ( | ^ wireFct = () | ) 

(wireFct _Define: foreignFct copyName: 'openGlue' 
                         Path: (unix environmentVariable: 'SELF_NEWS'), '/wireI.so')

traits system _AddSlotsIfAbsent: ( | ^ wireI = () | )
traits wireI _Define: ( | 
    _ parent* = traits proxy.
  
    ^ allocateTags: nTg = (
	| connection = wireFct copyName: 'allocateTagsGlue'. |
	connection value: self With: nTg
      ).

    ^ allocateTokens: nTk = (
	| connection = wireFct copyName: 'allocateTokensGlue'. |
	connection value: self With: nTk
      ).

    ^ deallocateToken: tk = (
	(wireFct copyName: 'deallocateTokenGlue') value: self With: tk
    ).

    ^ close = (
	| connection = wireFct copyName: 'closeGlue'. |
	connection value: self
      ).

    ^ current = (
	| connection = wireFct copyName: 'currentGlue'. |
	connection value
      ).

    ^ enable = (
	| connection = wireFct copyName: 'enableGlue'. |
	connection value: self
      ).

    ^ errorString = (
	| connection = wireFct copyName: 'errorStringGlue'. |
	connection value
      ).

    ^ open = ( open: '' ).
    ^ open: onDisplay = (
	| connection = wireFct copyName: 'openGlue'. |
	connection value: onDisplay With: deadCopy
      ).

    ^ readTag = (
	| connection = wireFct copyName: 'readTagGlue'. |
	connection value: self
      ).

    ^ readInteger = (
	| connection = wireFct copyName: 'readIntGlue'. |
	connection value: self
      ).

    ^ readString: s = (
	| connection = wireFct copyName: 'readStringGlue'. |
	connection value: self With: s
      ).

    ^ setCurrent = (
	| connection = wireFct copyName: 'setCurrentGlue'. |
	connection value: self
      ).

    ^ skipEvent = (
	| connection = wireFct copyName: 'skipEventGlue'. |
	connection value: self
      ).

    ^ valid = (
	| connection = wireFct copyName: 'validGlue'. |
	connection value: self
      ).

    ^ wouldNotify  = (
	| connection = wireFct copyName: 'wouldNotifyGlue'. |
	connection value: self
      ).

    ^ invalidWire = (
	| connection = wireFct copyName: 'invalidWireGlue'. |
	connection value: self
      ).

    ^ wireInputFd = (
	| connection = wireFct copyName: 'wireInputFdGlue'. |
	connection value: self
      ).

    ^ wireOutputFd = (
	| connection = wireFct copyName: 'wireOutputFdGlue'. |
	connection value: self
      ).

    ^ loadPackages = (
	| connection = wireFct copyName: 'loadPackagesGlue'. |
	connection value: self.
	self
      ).

    ^ send: psFragment = (
	| connection = wireFct copyName: 'sendGlue'. |
	connection value: self With: psFragment
      ).

    ^ sendTo: obj With: psFragment = (
	| connection = wireFct copyName: 'sendToGlue'. |
	connection value: self With: obj With: psFragment
      ).

    ^ syncReply: obj With: psFragment = (
	(wireFct copyName: 'syncReplyGlue') value: self With: obj With: psFragment
    ).

    ^ flushPostScript = (
	| connection = wireFct copyName: 'flushPostScriptGlue'. |
	connection value: self
      ).

    ^ peekTag = (
	| connection = wireFct copyName: 'peekTagGlue'. |
	connection value: self
    ).

    ^ messageOnWire = (
	| connection = wireFct copyName: 'checkInputGlue'. |
	connection value: self
    ).

    ^ fileDescriptor = ( wireOutputFd )
| )

prototypes system _AddSlotsIfAbsent: ( | ^ wireI = () | )
wireI _Define: proxy deadCopy _AddSlots: ( |
    _ parent* = traits wireI.
| )

oddballs system _AddSlotsIfAbsent: ( | ^ postScriptMachine = () | ) 
postScriptMachine _Define: ( | 
    _ parent* = traits oddball.

    ^ messageMachine  = wireI open.
    ^ messageSelf     = wireI open.
    ^ protMesgMach    = semaphore copyBinary.
    ^ protMesgSelf    = semaphore copyBinary.
    ^ objectBehaviour = dictionary copyRemoveAll.
    ^_ listener.

    ^ machineCalling = ( messageSelf messageOnWire ).

    ^ initialize = (
	messageMachine loadPackages.
	messageSelf loadPackages.
	messageSelf send: '
	    shareddict /MessageSelf currentfile put
	    shareddict /MessageSelfListenerProc currentprocess soften put
	    shareddict /MessageSelfProt createmonitor put
	    '.
	messageMachine send: '
	    shareddict /MessageMachine currentfile put
	    '.
	listener: (process copySend:
	    message copy receiver: self Selector: 'watchMachine') resume
    ).

    ^ watchMachine = ( | postScriptInput |
	postScriptInput:
	    unixFile copyFd: messageSelf fileDescriptor Name: 'messageSelf'.
	[
	    postScriptInput suspend.
	    machineCalling ifTrue: [ messageTarget ].
	    process this yield
	] loop
    ).

    _ messageTarget = ( | tg |
	[
	    tg: messageSelf peekTag.
	    (tg < 0) ifTrue: [ warning: 'postScriptMachine wire problem.' ].
	    (tg = 0) 
		ifTrue: [ "messageSelf flushPostScript" ]
		 False: [
		    (objectBehaviour includesKey: tg)
			ifTrue: [ (objectBehaviour at: tg) send ]
			 False: [ messageSelf readTag ]
		 ]
	] untilFalse: [ machineCalling ]
    ).

    ^ sendPS: psFragment = (
	protMesgMach protect: [ messageMachine send: psFragment ]
    ).

    ^ affect: objectReference With: action = (
	protMesgMach protect: [ messageMachine sendTo: objectReference With: action ]
    ).

    ^ behaviourFor: obj WithReprObj: reprObj On: evt Is: action = (
	objectBehaviour at: evt Put: message copy receiver: obj Selector: action
    ).

    ^ fashionReprObject = (
	messageMachine allocateTokens: 1
    ).

    ^ fashionAspects: aspects = (
	messageMachine allocateTags: aspects
    ).

    ^ reclaimResourcesFrom: visualisation = ( | reprBehav |
	messageMachine deallocateToken: visualisation representationObject.
	reprBehav: visualisation representationBehaviour.
	visualisation aspects do: [ | :aspect |
	    objectBehaviour removeKey: (reprBehav + aspect) - 1 IfAbsent: [
		warning: 'Object behaviour does not exist'
	    ]
	]
    )
| ) 

postScriptMachine initialize
